#!/usr/bin/perl
use strict;
use Data::Dumper;
use VR::API;

# environment variables needed by VR::API - fill in your values
$ENV{VR_API_SOAP_ENDPOINT} = 'https://api.verticalresponse.com/1.0/VRAPI';
$ENV{HTTPS_PKCS12_FILE} = "FIXME: path to your .p12 file";
$ENV{HTTPS_PKCS12_PASSWORD} = "FIXME: your .p12 fiel passphrase"; # Not needed for passphraseless PKCS#12 keystores

# login information - fill in your values
my $username = 'FIXME: your application login username (an email address)';
my $password = 'FIXME: your application login password';

print "logging in...\n";
my $vrapi = new VR::API;
my $sid = $vrapi->login( {
                          username => $username,
                          password => $password,
                          session_duration_minutes => 4
                         }
                       );

print "session ID is $sid \n";

# controls how many email and lists will be displayed
my $limit = 2;
# getting IDs for all lists
my $enum_results = $vrapi->enumerateLists(
                                          {
                                           session_id => $sid,
                                           type => 'email',
                                           limit => $limit,
                                          }
                                         );


#outputing the list IDs and name for each list within the account
print "Getting $limit  lists ....\n";
print "Outputing a customized view of the enumerateList output...\n";
my $size = scalar @{$enum_results};
for (my $i=0; $i< $size; $i++){
  print "Campaign name: " .  $enum_results->[$i]->{'name'};
  print "\tID: " . $enum_results->[$i]->{'id'} . "\n";  
}

print "Getting $limit email campaigns that have been sent... \n";

my $enum_camp = $vrapi->enumerateEmailCampaigns(
                                           {
                                            session_id => $sid,
                                            limit => $limit,
                                            statuses => ['sent']
                                           }
                                          );

print Dumper($enum_camp);

print "Reporting sample script done. \n";
